"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var subquery_exports = {};
__export(subquery_exports, {
  SelectionProxyHandler: () => SelectionProxyHandler,
  Subquery: () => Subquery,
  SubqueryConfig: () => SubqueryConfig,
  WithSubquery: () => WithSubquery
});
module.exports = __toCommonJS(subquery_exports);
var import_alias = require("./alias.cjs");
var import_column = require("./column.cjs");
var import_entity = require("./entity.cjs");
var import_sql = require("./sql/index.cjs");
var import_view_common = require("./view-common.cjs");
var import_view = require("./view.cjs");
const SubqueryConfig = Symbol.for("drizzle:SubqueryConfig");
class Subquery {
  static [import_entity.entityKind] = "Subquery";
  /** @internal */
  [SubqueryConfig];
  constructor(sql, selection, alias, isWith = false) {
    this[SubqueryConfig] = {
      sql,
      selection,
      alias,
      isWith
    };
  }
  getSQL() {
    return new import_sql.SQL([this]);
  }
}
class WithSubquery extends Subquery {
  static [import_entity.entityKind] = "WithSubquery";
}
class SelectionProxyHandler {
  static [import_entity.entityKind] = "SelectionProxyHandler";
  config;
  constructor(config) {
    this.config = { ...config };
  }
  get(subquery, prop) {
    if (prop === SubqueryConfig) {
      return {
        ...subquery[SubqueryConfig],
        selection: new Proxy(
          subquery[SubqueryConfig].selection,
          this
        )
      };
    }
    if (prop === import_view_common.ViewBaseConfig) {
      return {
        ...subquery[import_view_common.ViewBaseConfig],
        selectedFields: new Proxy(
          subquery[import_view_common.ViewBaseConfig].selectedFields,
          this
        )
      };
    }
    if (typeof prop === "symbol") {
      return subquery[prop];
    }
    const columns = (0, import_entity.is)(subquery, Subquery) ? subquery[SubqueryConfig].selection : (0, import_entity.is)(subquery, import_view.View) ? subquery[import_view_common.ViewBaseConfig].selectedFields : subquery;
    const value = columns[prop];
    if ((0, import_entity.is)(value, import_sql.SQL.Aliased)) {
      if (this.config.sqlAliasedBehavior === "sql" && !value.isSelectionField) {
        return value.sql;
      }
      const newValue = value.clone();
      newValue.isSelectionField = true;
      return newValue;
    }
    if ((0, import_entity.is)(value, import_sql.SQL)) {
      if (this.config.sqlBehavior === "sql") {
        return value;
      }
      throw new Error(
        `You tried to reference "${prop}" field from a subquery, which is a raw SQL field, but it doesn't have an alias declared. Please add an alias to the field using ".as('alias')" method.`
      );
    }
    if ((0, import_entity.is)(value, import_column.Column)) {
      if (this.config.alias) {
        return new Proxy(
          value,
          new import_alias.ColumnAliasProxyHandler(
            new Proxy(
              value.table,
              new import_alias.TableAliasProxyHandler(this.config.alias, this.config.replaceOriginalName ?? false)
            )
          )
        );
      }
      return value;
    }
    if (typeof value !== "object" || value === null) {
      return value;
    }
    return new Proxy(value, new SelectionProxyHandler(this.config));
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  SelectionProxyHandler,
  Subquery,
  SubqueryConfig,
  WithSubquery
});
//# sourceMappingURL=subquery.cjs.map