import { entityKind } from "./entity.js";
import { SQL } from "./sql/index.js";
import { ViewBaseConfig } from "./view-common.js";
class View {
  static [entityKind] = "View";
  /** @internal */
  [ViewBaseConfig];
  constructor({ name, schema, selectedFields, query }) {
    this[ViewBaseConfig] = {
      name,
      originalName: name,
      schema,
      selectedFields,
      query,
      isExisting: !query,
      isAlias: false
    };
  }
  getSQL() {
    return new SQL([this]);
  }
}
export {
  View
};
//# sourceMappingURL=view.js.map